#ifndef __phasertng_table_sigesq_centric_class__
#define __phasertng_table_sigesq_centric_class__
#include <set>
#include <map>
#include <phasertng/main/Assert.h>

namespace phasertng {
namespace table {

class sigesq_centric
{
  // For centrics, log(sigesq) as a function of log(expected info target) is
  // given below, with some exact values that are likely to be chosen filled in.
  private:
  std::map<double, double> logsigesqs;

  public:
  sigesq_centric()
  {
    logsigesqs = {
      {-8.76229, 4.56435}, {-8.51726, 4.44182}, {-8.27223, 4.31928},
      {-8.02722, 4.19675}, {-7.78221, 4.07422}, {-7.53723, 3.95169},
      {-7.29227, 3.82915}, {-7.04733, 3.70662}, {-6.80244, 3.58409},
      {-6.55759, 3.46156}, {-6.3128, 3.33902}, {-6.06809, 3.21649},
      {-5.82348, 3.09396}, {-5.579, 2.97143}, {-5.33468, 2.84889},
      {-5.09058, 2.72636}, {-4.84676, 2.60383}, {-4.6033, 2.4813},
      {-4.36033, 2.35877}, {-4.11799, 2.23623}, {-3.8765, 2.1137},
      {-3.63615, 1.99117}, {-3.39736, 1.86864}, {-3.16066, 1.7461},
      {-2.92679, 1.62357}, {-2.69663, 1.50104}, {-2.47118, 1.37851},
      {-2.25151, 1.25597}, {-2.03865, 1.13344}, {-1.83348, 1.01091},
      {-1.63672, 0.888376}, {-1.44884, 0.765844}, {-1.2701, 0.643312},
      {-1.10057, 0.520779}, {-0.940118, 0.398247}, {-0.788506, 0.275714},
      {-0.645387, 0.153182}, {-0.510354, 0.0306497}, {-0.382962, -0.0918827},
      {-0.262749, -0.214415}, {-0.149253, -0.336947}, {-0.0420209, -0.45948},
      {0.0585951, -0.582012}, {0.15471, -0.704545}, {0.245057, -0.827077},
      {0.331876, -0.949609}, {0.413909, -1.07214}, {0.49153, -1.19467},
      {0.566381, -1.31721}, {0.63704, -1.43974}, {0.704617, -1.56227},
      {0.769481, -1.6848}, {0.831376, -1.80734}, {0.890337, -1.92987},
      {0.947502, -2.0524}, {1.00139, -2.17493}, {1.05414, -2.29747},
      {1.10475, -2.42}, {1.1532, -2.54253}, {1.19983, -2.66506},
      {1.24501, -2.7876}, {1.28838, -2.91013}, {1.33065, -3.03266},
      {1.37127, -3.15519}, {1.41072, -3.27772}, {1.449, -3.40026},
      {1.48607, -3.52279}, {1.52194, -3.64532}, {1.55669, -3.76785},
      {1.59053, -3.89039}, {1.62359, -4.01292}, {1.65554, -4.13545},
      {1.68667, -4.25798}, {1.71703, -4.38052}, {1.7465, -4.50305},
      {1.77528, -4.62558}, {1.80335, -4.74811}, {1.83085, -4.87065},
      {1.85751, -4.99318}, {1.88364, -5.11571}, {1.90916, -5.23824},
      {1.93412, -5.36078}, {1.9585, -5.48331}, {1.98233, -5.60584},
      {2.00566, -5.72837}, {2.02859, -5.85091}, {2.05097, -5.97344},
      {2.07283, -6.09597}, {2.09431, -6.2185}, {2.11538, -6.34103},
      {2.13608, -6.46357}, {2.15632, -6.5861}, {2.17619, -6.70863},
      {2.19572, -6.83116}, {2.21489, -6.9537}, {2.23365, -7.07623},
      {2.25216, -7.19876}, {2.27035, -7.32129}, {2.28822, -7.44383},
      {2.30578, -7.56636}, {2.32303, -7.68889}, {2.34, -7.81142},
      {2.35673, -7.93396}, {2.37317, -8.05649}, {2.38933, -8.17902},
      {2.40527, -8.30155}, {2.42099, -8.42409}, {2.43644, -8.54662},
      {2.45163, -8.66915}, {2.46666, -8.79168}, {2.48143, -8.91421},
      {2.496, -9.03675}, {2.51037, -9.15928}, {2.52453, -9.28181},
      {2.5385, -9.40434}, {2.55226, -9.52688}, {2.56584, -9.64941},
      {2.57926, -9.77194}, {2.59248, -9.89447}, {2.60556, -10.017},
      {2.61845, -10.1395}, {2.63118, -10.2621}, {2.64373, -10.3846},
      {2.65616, -10.5071}, {2.66842, -10.6297}, {2.68052, -10.7522},
      {2.6925, -10.8747}, {2.70434, -10.9973}, {2.71603, -11.1198},
      {2.72757, -11.2423}, {2.73899, -11.3649}, {2.75029, -11.4874},
      {2.76146, -11.6099}, {2.77252, -11.7325}, {2.78344, -11.855},
      {2.79424, -11.9775}, {2.80493, -12.1001}, {2.81551, -12.2226},
      {2.82599, -12.3451}, {2.83637, -12.4677}, {2.84663, -12.5902},
      {2.85677, -12.7127}, {2.86685, -12.8353}, {2.87679, -12.9578},
      {2.88668, -13.0803}, {2.89645, -13.2028}, {2.90607, -13.3254},
      {2.91575, -13.4479}, {2.9251, -13.5704}, {2.93464, -13.693},
      {2.94396, -13.8155}
    };

    std::pair<double,double> exact;
    exact.first = std::log(0.001), exact.second =  3.63679;
    logsigesqs.insert(exact);
    exact.first = std::log(0.005), exact.second = 2.83065;
    logsigesqs.insert(exact);
    exact.first = std::log(0.01), exact.second = 2.48224;
    logsigesqs.insert(exact);
    exact.first = std::log(0.05), exact.second = 1.65987;
    logsigesqs.insert(exact);
    exact.first = std::log(0.1), exact.second = 1.28478;
    logsigesqs.insert(exact);
    exact.first = std::log(0.5), exact.second = 0.19487;
    logsigesqs.insert(exact);
    exact.first = std::log(1.), exact.second = -0.50943;
    logsigesqs.insert(exact);
  }

  double get(double info)
  {
    phaser_assert(info > 0);
    double loginfo = std::log(info);
    // First check for exact match
    for (auto item : logsigesqs)
      if (loginfo == item.first)
        return std::exp(item.second);
    // For very little information beyond table, use linear extrapolation formula
    if (loginfo <= logsigesqs.begin()->first)
    {
      double arg = std::min(0.18306 - 0.500018 * loginfo,70.);
      return std::exp(arg);
    }
    // For very high information, cap sigesq to smallest value in table
    if (loginfo >= logsigesqs.rbegin()->first)
      return std::exp(logsigesqs.rbegin()->second);
    // Interpolate within table bounds
    double i1 = logsigesqs.begin()->first;
    double s1 = logsigesqs.begin()->second;
    double i2 = logsigesqs.begin()->first;
    double s2 = logsigesqs.begin()->second;
    for (auto item : logsigesqs)
    {
      if (loginfo < item.first)
      {
        i2 = item.first;
        s2 = item.second;
        break;
      }
      i1 = item.first;
      s1 = item.second;
    }
    double val(s1 + (loginfo-i1)*(s2-s1)/(i2-i1));
    return std::exp(val);
  }
};

}}
#endif
